
#include <vfw.h>

class CCodecCtrl : public COleControl
{
	DECLARE_DYNCREATE(CCodecCtrl)

public:
	CCodecCtrl();

	//{{AFX_VIRTUAL(CCodecCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

protected:
	~CCodecCtrl();

	DECLARE_OLECREATE_EX(CCodecCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CCodecCtrl)      // GetTypeInfo
	DECLARE_OLECTLTYPE(CCodecCtrl)		// Type name and misc status

	//{{AFX_MSG(CCodecCtrl)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	//{{AFX_DISPATCH(CCodecCtrl)
	short m_quality;
	CString m_codec;
	afx_msg void OnCodecChanged();
	short m_frameNr;
	short m_keyFrame;
	afx_msg void OnKeyFrameChanged();
	afx_msg void EncodeFrame(long bmph, long data, long size);
	afx_msg void DecodeFrame(long bmph, long data, long size);
	afx_msg void SelectCodec();
	afx_msg void NoCodec();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

	//{{AFX_EVENT(CCodecCtrl)
	void FireOnFrame(long bmph, long data, long size)
		{FireEvent(eventidOnFrame,EVENT_PARAM(VTS_I4  VTS_I4  VTS_I4), bmph, data, size);}
	void FireResize(long x, long y)
		{FireEvent(eventidResize,EVENT_PARAM(VTS_I4  VTS_I4), x, y);}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

public:
	enum {
	//{{AFX_DISP_ID(CCodecCtrl)
	dispidCodec = 2L,
	dispidFrameNr = 3L,
	dispidKeyFrame = 4L,
	dispidQuality = 1L,
	dispidEncodeFrame = 5L,
	dispidDecodeFrame = 6L,
	dispidSelectCodec = 7L,
	dispidNoCodec = 8L,
	eventidOnFrame = 1L,
	eventidResize = 2L,
	//}}AFX_DISP_ID
	};

   COMPVARS m_compvars;
   BITMAPINFOHEADER* m_bmph;  // Ausgangs-BmpH
   char *m_prevbmph;
   HIC m_hic;
   ICINFO m_icinfo;
   ULONG m_biCompression;
   long m_Width, m_Height, m_BitCount;
   int m_flag;  // =1 wenn Ausgangs-BmpH gesetzt werden soll
   int m_begin; // =1 wenn innerhalb von CompressBegin...End
   char *m_puffer, *m_prevpuffer;
   long m_prevpuffersize;
   void resetcodec(void);
};
