
#include "mixx.h"

class CConstantRateWindow;
#define WM_THREADFIREEVENT WM_USER+101

class CConstantRateCtrl: public COleControl, public ConstantRate
{
	DECLARE_DYNCREATE(CConstantRateCtrl)

public:
	CConstantRateCtrl();

	//{{AFX_VIRTUAL(CConstantRateCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

protected:
	~CConstantRateCtrl();

	DECLARE_OLECREATE_EX(CConstantRateCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CConstantRateCtrl)      // GetTypeInfo
	DECLARE_OLECTLTYPE(CConstantRateCtrl)		// Type name and misc status

	//{{AFX_MSG(CConstantRateCtrl)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	//{{AFX_DISPATCH(CConstantRateCtrl)
	long m_bufferSize;
	afx_msg void OnBufferSizeChanged();
	long m_dataRate;
	afx_msg void OnDataRateChanged();
	long m_blockSize;
	afx_msg void OnBlockSizeChanged();
	BOOL m_sending;
	afx_msg void OnSendingChanged();
	CString m_Host;
	afx_msg void OnHostChanged();
	short m_Port;
	afx_msg void OnPortChanged();
	BOOL m_receiving;
	afx_msg void OnReceivingChanged();
	short m_type;
	afx_msg void OnTypeChanged();
	afx_msg short GetBufferFilled();
	afx_msg BSTR GetPeerName();
	afx_msg BOOL Send(long data, long size);
	afx_msg void Taken(long size);
	afx_msg long Data1();
	afx_msg long Data2();
	afx_msg long Size1();
	afx_msg long Size2();
	afx_msg void MessageBox(LPCTSTR txt, short flag, LPCTSTR caption);
	afx_msg void ClearBuffer();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

public:
	//{{AFX_EVENT(CConstantRateCtrl)
	void FireReceive(long data, long size)
		{FireEvent(eventidReceive,EVENT_PARAM(VTS_I4  VTS_I4), data, size);}
	void FireOverflow()
		{FireEvent(eventidOverflow,EVENT_PARAM(VTS_NONE));}
	void FireDisconnect()
		{FireEvent(eventidDisconnect,EVENT_PARAM(VTS_NONE));}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

public:
	enum {
	//{{AFX_DISP_ID(CConstantRateCtrl)
	dispidBufferFilled = 9L,
	dispidBufferSize = 1L,
	dispidDataRate = 2L,
	dispidBlockSize = 3L,
	dispidSending = 4L,
	dispidHost = 5L,
	dispidPort = 6L,
	dispidReceiving = 7L,
	dispidType = 8L,
	dispidPeerName = 10L,
	dispidSend = 11L,
	dispidTaken = 12L,
	dispidData1 = 13L,
	dispidData2 = 14L,
	dispidSize1 = 15L,
	dispidSize2 = 16L,
	dispidMessageBox = 17L,
	dispidClearBuffer = 18L,
	eventidReceive = 1L,
	eventidOverflow = 2L,
	eventidDisconnect = 3L,
	//}}AFX_DISP_ID
	};

   Buffer puffer;
   int initflag;
   void OnReceive(char *adr, int size);
   void OnOverflow(void);
   void OnDisconnect(void);

   char *tmp_adr;
   long tmp_size;
   HWND hwndTarget;
   CConstantRateWindow *mywnd;
   int status;
};

class CConstantRateWindow: public CWnd
{
public:
	CConstantRateWindow(CConstantRateCtrl *pCtrl) { m_pControl=pCtrl; }
	LRESULT OnFireEventForThread(WPARAM wParam, LPARAM lParam);
	HWND Create();

protected:
	CConstantRateCtrl *m_pControl;
	DECLARE_MESSAGE_MAP()
};
